package edu.mit.csail.pag.recrash.transformation;

import java.util.List;

import org.objectweb.asm.Opcodes;
import org.objectweb.asm.tree.ClassNode;
import org.objectweb.asm.tree.InsnList;
import org.objectweb.asm.tree.InsnNode;
import org.objectweb.asm.tree.LabelNode;
import org.objectweb.asm.tree.LocalVariableNode;
import org.objectweb.asm.tree.MethodInsnNode;
import org.objectweb.asm.tree.MethodNode;
import org.objectweb.asm.tree.TryCatchBlockNode;
import org.objectweb.asm.tree.VarInsnNode;

public class Clonning implements Opcodes {
	@SuppressWarnings("unchecked")
	static MethodNode addCloneMethodOld(final ClassNode cn) {
		MethodNode cloneMethod = new MethodNode(ACC_PUBLIC, "clone",
				"()Ljava/lang/Object;", null, null);

		InsnList il = cloneMethod.instructions;

		List localVariables = cloneMethod.localVariables;
		List tryCatchBolcks = cloneMethod.tryCatchBlocks;

		LabelNode L0 = new LabelNode();
		LabelNode L1 = new LabelNode();
		LabelNode L2 = new LabelNode();
		LabelNode L3 = new LabelNode();
		LabelNode L4 = new LabelNode();

		il.add(L0);
		il.add(new VarInsnNode(ALOAD, 0));
		il.add(new MethodInsnNode(INVOKESPECIAL, cn.superName, "clone",
				"()Ljava/lang/Object;"));
		il.add(new InsnNode(ARETURN));
		il.add(L1);
		il.add(L2);
		il.add(new VarInsnNode(ASTORE, 1));
		il.add(L3);
		il.add(new VarInsnNode(ALOAD, 0));
		il.add(new InsnNode(ARETURN));
		il.add(L4);

		tryCatchBolcks.add(new TryCatchBlockNode(L0, L1, L2,
				"java/lang/Throwable"));

		if (false) {
			// ###FIXME:
			// Better way to do this rather that do L + cn.name + ;
			localVariables.add(new LocalVariableNode("this", "L" + cn.name
					+ ";", null, L0, L4, 0));

			/*
			 * System.err.println(cn.name + " <<::: " +
			 * Type.getObjectType(cn.name).get.getInternalName());
			 */
			localVariables.add(new LocalVariableNode("e",
					"Ljava.lang.CloneNotSupportedException;", null, L3, L4, 1));
		}
		cloneMethod.maxStack = 1;
		cloneMethod.maxLocals = 2;
		return cloneMethod;
	}

}
