package edu.mit.csail.pag.recrash.transformation;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.LinkedHashSet;
import java.util.Set;

import org.objectweb.asm.tree.ClassNode;
import org.objectweb.asm.tree.MethodNode;

import edu.mit.csail.pag.recrash.Logger;
import edu.mit.csail.pag.recrash.Util;

public class SecondChangeMode {

	Set<String> methodInBackStackTrace = new LinkedHashSet<String>();

	// com.sun.tools.javac.comp.Attr.visitMethodDef(Attr.java:722)
	// com.sun.tools.javac.tree.JCTree$JCMethodDecl.accept(JCTree.java:672)
	// com.sun.tools.javac.comp.Attr.attribTree(Attr.java:375)
	// com.sun.tools.javac.comp.Attr.attribStat(Attr.java:412)
	// com.sun.tools.javac.comp.Attr.attribClassBody(Attr.java:3026)
	// com.sun.tools.javac.comp.Attr.attribClass(Attr.java:2952)
	// com.sun.tools.javac.comp.Attr.attribClass(Attr.java:2888)
	// com.sun.tools.javac.main.JavaCompiler.attribute(JavaCompiler.java:1114)
	// com.sun.tools.javac.main.JavaCompiler.attribute(JavaCompiler.java:1090)
	// com.sun.tools.javac.main.JavaCompiler.compile0(JavaCompiler.java:745)
	// com.sun.tools.javac.main.Main.compile(Main.java:389)
	// com.sun.tools.javac.main.Main.compile(Main.java:309)
	// com.sun.tools.javac.main.Main.compile(Main.java:300)
	// com.sun.tools.javac.Main.compile(Main.java:86)
	// com.sun.tools.javac.Main.main(Main.java:71)
	public SecondChangeMode(String backStackTraceFile) throws IOException {
		BufferedReader br = new BufferedReader(new FileReader(
				backStackTraceFile));
		while (true) {
			String line = br.readLine();
			if (line == null) {
				break;
			}

			if (line.length() == 0 || line.charAt(0) == '#') {
				continue;
			}

			int cutPoint = line.indexOf('(');
			if (cutPoint == -1) {
				continue;
			}

			String toAdd = line.substring(0, cutPoint);
			methodInBackStackTrace.add(toAdd);
		}
		Logger.info(methodInBackStackTrace.size()
				+ " backStackTrace are added!");
		br.close();
	}

	public boolean amIinTheBackStrackTrace(ClassNode cn, MethodNode mn) {
		String fullMethodName = Util.transClassNameSlashToDot(cn.name + "."
				+ mn.name);

		Logger.debug("[BACKTrace] " + fullMethodName);
		return methodInBackStackTrace.contains(fullMethodName);
	}
}
